% SAR - LEZ SVM for object recognition
% lezioni ispirate a http://www.vlfeat.org/applications/caltech-101-code.html
% Gli esercizi funzionano dopo aver installato il toolbox vlfeat-0.9.18 (e aver seguito il readme di installazione) e
% aver linkato correttamente il codice sottostante


clear all;
clc;
%close all

dire = 'H:\MATLAB\vlfeat-0.9.18\'
% addpath to the libsvm toolbox
eval(['run ',dire,'toolbox\vl_setup'])

eval(['cd ',dire,'\apps'])
phow_caltech101()
%phow_caltech101MARCO() % visualizza le codewords (Es 3 sotto)
%phow_caltech101MARCOcsBoW() % utilizza un vocabolario specifico per persona (Es 4 sotto)

eval(['cd ',dire,'\apps\data'])



%% ESERCIZI
% Ogni volta che vado a provare una nuova configurazione, 
% devo cancellare tutti i mat finora creati nella directory data, a meno del mat dei 
% risultati!!! (Per risparmiare tempo, lasciate la matrice tiny-vocab)

% Per ognuno degli esempi sottostanti, calcolarsi l'accuratezza
%1) eseguire il semplice BoW + SVM visto a lezione 
%2) aumentare la cardinalita' dei quadranti dello spatial histogram

% In pratica, qui sopra sto variando la struttura spaziale del
% classificatore. Alla fine voglio vedere un grafico in cui, al variare
% della spazialita' degli istogrammi, mi mostri l'accuratezza.

% accu_tot = [];
% siz_tot = [1,2,4,6,8,10,12,16,24,64];
% siz_tot = [2];
% for siz = siz_tot
%     load(strcat('tiny-result_NumC_5__nX_',num2str(siz),'__nY_',num2str(siz),'__nW_300'))
%     accu_tot = [accu_tot,accu];
% end
% figure; plot(siz_tot, accu_tot);
% xlabel('numero di quadranti per lato');
% ylabel('accuratezza')




%3) visualizzare le visual words; per capire al volo cosa sono le sift, si
      % guardi http://docs.opencv.org/trunk/doc/py_tutorials/py_feature2d/py_sift_intro/py_sift_intro.html

%    PASSI:
%    
%    a) capire dove sono estratte nell'immagine le features salienti (SIFT)
%    b) capire qual'e' la grandezza del supporto spaziale (patch) che viene 
%     descritta dalla feature
%    c) capire, data una particolare feature, a che visual words essa faccia riferimento
%    d) prendere tutte le visual words (ovvero tutte la patch corrispondenti
%     ad una particolare visual word) di tutte le immagini usate come training,
%     e mediarle (una volta avendole trasformate in livelli di grigio)
%    e) costruire un collage di tutte le rappresentazioni di parole visuali cosi' 
%     calcolate 


% 4) Costruire un class specific vocabulary, in cui su ogni classe del dataset addestro kmeans e costruisco una serie di codewords. 
% valutare le performances di accuratezza 
